/*! \file obs.h
 *  \brief Various observation models
 */

#ifndef OBS_H
#define OBS_H

#include "func.h"

/// The multi-track observation model
/*! \todo test this */
Func *multitrack_obs(int n, int k, int *tracks, int *obs,
                            Func::val_t p);

/// The single track observation model
Func *singletrack_obs(int n, int i, int j, Func::val_t pi);

/// The bluetooth observation model
/*! \todo which one?
 * \todo test this */
Func *bluetooth_obs(int n, int k, int *tracks, int *obs,
                           Func::val_t pi);

/// The pairwise ranking observation model
/*! The pairwise ranking model is defined as pi for permutations p
 *  where p(i) < p(j) and 1 - pi otherwise
 */
Func *pair_rank_obs(int n, int i, int j, Func::val_t pi);

#endif
