%module props
%{
#include <iostream>
using namespace std;

#define SWIG_FILE_WITH_INIT
%}
%include numpy.i
%init %{
import_array();
%}

%include std_vector.i
%include std_pair.i


/* see notes on IT++ in README.h */

%typemap(out) itpp::mat
{
        npy_intp dims[] = {$1.rows(), $1.cols()};

        /* the 1 means column-major "Fortran-style" contiguous;
           this is how IT++ appears to store its matrix data, though
           I can't confirm this from the documentation */
        PyObject *c = PyArray_EMPTY(2, dims, PyArray_DOUBLE, 1);

        void *arr_data = PyArray_DATA((PyArrayObject *)c);

        memcpy(arr_data, $1._data(), sizeof(double) * dims[0]*dims[1]);

        $result = c;
}


%typemap(out) Matrix
{
        npy_intp dims[] = {$1.rows, $1.cols};

        PyObject *c = PyArray_SimpleNew(2, dims, PyArray_DOUBLE);

        void *arr_data = PyArray_DATA((PyArrayObject *)c);

        memcpy(arr_data, $1.mat, sizeof(double) * dims[0]*dims[1]);

        $result = c;
}

%rename(__str__) str;
%rename(__repr__) repr;

namespace std {
%template(intvec) vector<int>;
%template(doublevec) vector<double>;
%template(intvecvec) vector<vector<int> >;
}

%include permutation.i
%include util.i
%include func.i
%include dist.i
%include partition.i
%include fourier.i
%include fourierfunc.i
%include obs.i
%include models.i

