#!/usr/bin/perl -w

use strict;

sub prof {
        my ($prog, $fun) = @_;
        my $units;
        open PROF, "gprof $prog|";
        while (<PROF>) {
                if (/(\w+)\/call/) {
                        if ($1 eq "ns") {
                                $units = 1;
                        } elsif ($1 eq "us") {
                                $units = 1000;
                        } elsif ($1 eq "ms") {
                                $units = 1e6;
                        } elsif ($1 eq "s") {
                                $units = 1e9;
                        }
                }
                if (/([\d\.]+) +$fun/) {
                        return $1 * $units;
                }
        }
}

my ($i, $reps, $t);

print "# profiling snob\n";
for ($i = 2; $i <= 8; $i++) {
        $reps = 10**(8-$i);
        system("./SnOB/examples/speedtest $i $reps > /dev/null");
        $t = prof("SnOB/examples/speedtest", "Sn::Function::FFT");
        print "$i $t\n";
}

print "\n\n# profiling props\n";
for ($i = 1; $i <= 8; $i++) {
        $reps = 10**(8-$i);
        system("./speedtest $i $reps > /dev/null");
        $t = prof("speedtest", "Func::fft");

        print "$i $t\n";
}
